/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://code.google.com/p/google-apis-client-generator/
 * (build: 2013-06-26 16:27:34 UTC)
 * on 2013-07-24 at 13:33:30 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.identitytoolkit.model;

/**
 * Request to get the IDP authentication URL.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Google Identity Toolkit API. For a detailed
 * explanation see:
 * <a href="http://code.google.com/p/google-api-java-client/wiki/Json">http://code.google.com/p/google-api-java-client/wiki/Json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class IdentitytoolkitRelyingpartyCreateAuthUriRequest extends com.google.api.client.json.GenericJson {

  /**
   * The relying party OAuth client ID.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String clientId;

  /**
   * The opaque value used by the client to maintain context info between the authentication request
   * and the IDP callback.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String context;

  /**
   * The URI to which the IDP redirects the user after the federated login flow.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String continueUri;

  /**
   * The email or federated ID of the user.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String identifier;

  /**
   * Optional realm for OpenID protocol. The sub string "scheme://domain:port" of the param
   * "continueUri" is used if this is not set.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String openidRealm;

  /**
   * The IdP ID. For white listed IdPs it's a short domain name e.g. google.com, aol.com, live.net
   * and yahoo.com. For other OpenID IdPs it's the OP identifier.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String providerId;

  /**
   * The relying party OAuth client ID.
   * @return value or {@code null} for none
   */
  public java.lang.String getClientId() {
    return clientId;
  }

  /**
   * The relying party OAuth client ID.
   * @param clientId clientId or {@code null} for none
   */
  public IdentitytoolkitRelyingpartyCreateAuthUriRequest setClientId(java.lang.String clientId) {
    this.clientId = clientId;
    return this;
  }

  /**
   * The opaque value used by the client to maintain context info between the authentication request
   * and the IDP callback.
   * @return value or {@code null} for none
   */
  public java.lang.String getContext() {
    return context;
  }

  /**
   * The opaque value used by the client to maintain context info between the authentication request
   * and the IDP callback.
   * @param context context or {@code null} for none
   */
  public IdentitytoolkitRelyingpartyCreateAuthUriRequest setContext(java.lang.String context) {
    this.context = context;
    return this;
  }

  /**
   * The URI to which the IDP redirects the user after the federated login flow.
   * @return value or {@code null} for none
   */
  public java.lang.String getContinueUri() {
    return continueUri;
  }

  /**
   * The URI to which the IDP redirects the user after the federated login flow.
   * @param continueUri continueUri or {@code null} for none
   */
  public IdentitytoolkitRelyingpartyCreateAuthUriRequest setContinueUri(java.lang.String continueUri) {
    this.continueUri = continueUri;
    return this;
  }

  /**
   * The email or federated ID of the user.
   * @return value or {@code null} for none
   */
  public java.lang.String getIdentifier() {
    return identifier;
  }

  /**
   * The email or federated ID of the user.
   * @param identifier identifier or {@code null} for none
   */
  public IdentitytoolkitRelyingpartyCreateAuthUriRequest setIdentifier(java.lang.String identifier) {
    this.identifier = identifier;
    return this;
  }

  /**
   * Optional realm for OpenID protocol. The sub string "scheme://domain:port" of the param
   * "continueUri" is used if this is not set.
   * @return value or {@code null} for none
   */
  public java.lang.String getOpenidRealm() {
    return openidRealm;
  }

  /**
   * Optional realm for OpenID protocol. The sub string "scheme://domain:port" of the param
   * "continueUri" is used if this is not set.
   * @param openidRealm openidRealm or {@code null} for none
   */
  public IdentitytoolkitRelyingpartyCreateAuthUriRequest setOpenidRealm(java.lang.String openidRealm) {
    this.openidRealm = openidRealm;
    return this;
  }

  /**
   * The IdP ID. For white listed IdPs it's a short domain name e.g. google.com, aol.com, live.net
   * and yahoo.com. For other OpenID IdPs it's the OP identifier.
   * @return value or {@code null} for none
   */
  public java.lang.String getProviderId() {
    return providerId;
  }

  /**
   * The IdP ID. For white listed IdPs it's a short domain name e.g. google.com, aol.com, live.net
   * and yahoo.com. For other OpenID IdPs it's the OP identifier.
   * @param providerId providerId or {@code null} for none
   */
  public IdentitytoolkitRelyingpartyCreateAuthUriRequest setProviderId(java.lang.String providerId) {
    this.providerId = providerId;
    return this;
  }

  @Override
  public IdentitytoolkitRelyingpartyCreateAuthUriRequest set(String fieldName, Object value) {
    return (IdentitytoolkitRelyingpartyCreateAuthUriRequest) super.set(fieldName, value);
  }

  @Override
  public IdentitytoolkitRelyingpartyCreateAuthUriRequest clone() {
    return (IdentitytoolkitRelyingpartyCreateAuthUriRequest) super.clone();
  }

}
