/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://code.google.com/p/google-apis-client-generator/
 * (build: 2013-06-26 16:27:34 UTC)
 * on 2013-07-24 at 13:33:30 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.identitytoolkit.model;

/**
 * Request to upload user account in batch.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Google Identity Toolkit API. For a detailed
 * explanation see:
 * <a href="http://code.google.com/p/google-api-java-client/wiki/Json">http://code.google.com/p/google-api-java-client/wiki/Json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class IdentitytoolkitRelyingpartyUploadAccountRequest extends com.google.api.client.json.GenericJson {

  /**
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String hashAlgorithm;

  /**
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Integer memoryCost;

  /**
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Integer rounds;

  /**
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String saltSeparator;

  /**
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String signerKey;

  /**
   * The account info to be stored.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<Userinfo> userAccount;

  static {
    // hack to force ProGuard to consider Userinfo used, since otherwise it would be stripped out
    // see http://code.google.com/p/google-api-java-client/issues/detail?id=528
    com.google.api.client.util.Data.nullOf(Userinfo.class);
  }

  /**
   * @return value or {@code null} for none
   */
  public java.lang.String getHashAlgorithm() {
    return hashAlgorithm;
  }

  /**
   * @param hashAlgorithm hashAlgorithm or {@code null} for none
   */
  public IdentitytoolkitRelyingpartyUploadAccountRequest setHashAlgorithm(java.lang.String hashAlgorithm) {
    this.hashAlgorithm = hashAlgorithm;
    return this;
  }

  /**
   * @return value or {@code null} for none
   */
  public java.lang.Integer getMemoryCost() {
    return memoryCost;
  }

  /**
   * @param memoryCost memoryCost or {@code null} for none
   */
  public IdentitytoolkitRelyingpartyUploadAccountRequest setMemoryCost(java.lang.Integer memoryCost) {
    this.memoryCost = memoryCost;
    return this;
  }

  /**
   * @return value or {@code null} for none
   */
  public java.lang.Integer getRounds() {
    return rounds;
  }

  /**
   * @param rounds rounds or {@code null} for none
   */
  public IdentitytoolkitRelyingpartyUploadAccountRequest setRounds(java.lang.Integer rounds) {
    this.rounds = rounds;
    return this;
  }

  /**
   * @see #decodeSaltSeparator()
   * @return value or {@code null} for none
   */
  public java.lang.String getSaltSeparator() {
    return saltSeparator;
  }

  /**

   * @see #getSaltSeparator()
   * @return Base64 decoded value or {@code null} for none
   *
   * @since 1.14
   */
  public byte[] decodeSaltSeparator() {
    return com.google.api.client.util.Base64.decodeBase64(saltSeparator);
  }

  /**
   * @see #encodeSaltSeparator()
   * @param saltSeparator saltSeparator or {@code null} for none
   */
  public IdentitytoolkitRelyingpartyUploadAccountRequest setSaltSeparator(java.lang.String saltSeparator) {
    this.saltSeparator = saltSeparator;
    return this;
  }

  /**

   * @see #setSaltSeparator()
   *
   * <p>
   * The value is encoded Base64 or {@code null} for none.
   * </p>
   *
   * @since 1.14
   */
  public IdentitytoolkitRelyingpartyUploadAccountRequest encodeSaltSeparator(byte[] saltSeparator) {
    this.saltSeparator = com.google.api.client.util.Base64.encodeBase64URLSafeString(saltSeparator);
    return this;
  }

  /**
   * @see #decodeSignerKey()
   * @return value or {@code null} for none
   */
  public java.lang.String getSignerKey() {
    return signerKey;
  }

  /**

   * @see #getSignerKey()
   * @return Base64 decoded value or {@code null} for none
   *
   * @since 1.14
   */
  public byte[] decodeSignerKey() {
    return com.google.api.client.util.Base64.decodeBase64(signerKey);
  }

  /**
   * @see #encodeSignerKey()
   * @param signerKey signerKey or {@code null} for none
   */
  public IdentitytoolkitRelyingpartyUploadAccountRequest setSignerKey(java.lang.String signerKey) {
    this.signerKey = signerKey;
    return this;
  }

  /**

   * @see #setSignerKey()
   *
   * <p>
   * The value is encoded Base64 or {@code null} for none.
   * </p>
   *
   * @since 1.14
   */
  public IdentitytoolkitRelyingpartyUploadAccountRequest encodeSignerKey(byte[] signerKey) {
    this.signerKey = com.google.api.client.util.Base64.encodeBase64URLSafeString(signerKey);
    return this;
  }

  /**
   * The account info to be stored.
   * @return value or {@code null} for none
   */
  public java.util.List<Userinfo> getUserAccount() {
    return userAccount;
  }

  /**
   * The account info to be stored.
   * @param userAccount userAccount or {@code null} for none
   */
  public IdentitytoolkitRelyingpartyUploadAccountRequest setUserAccount(java.util.List<Userinfo> userAccount) {
    this.userAccount = userAccount;
    return this;
  }

  @Override
  public IdentitytoolkitRelyingpartyUploadAccountRequest set(String fieldName, Object value) {
    return (IdentitytoolkitRelyingpartyUploadAccountRequest) super.set(fieldName, value);
  }

  @Override
  public IdentitytoolkitRelyingpartyUploadAccountRequest clone() {
    return (IdentitytoolkitRelyingpartyUploadAccountRequest) super.clone();
  }

}
